/*---------------------------------------------------------------------------

												Globals					   v1.0 
  Eneko Bilbao 1999
---------------------------------------------------------------------------*/

/* Comment
    include all what's needed
    declars the 2 mains linked lists object and map
    defines the viewport.
    defines texture indexes.
    
*/

#ifndef _GLOBALS_H_
#define _GLOBALS_H_

/* specific includes */
#include "model.h"
#include "actor.h"
#include "camera.h"
#include "imageLoader.h"
#include "texture.h"
#include "utility.h"
#include "linked_list.h"

/*- materials and lights definitions -*/
#include "materials.h"
#include "lights.h"

/* ANSI C includes */
#include <math.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>

/* openGL includes */
#include<glut.h>
    

/*- viewport definition -*/

#ifdef _USE_3DFX_
static int SCREEN_WIDTH = 640;
static int SCREEN_HEIGHT = 480;
static int SCREEN_X_CENTER = 320;
static int SCREEN_Y_CENTER = 240;
static float ASPECT_RATIO = (float)SCREEN_WIDTH/(float)SCREEN_HEIGHT;
#else
static int SCREEN_WIDTH = 320;
static int SCREEN_HEIGHT = 240;
static int SCREEN_X_CENTER = 160;
static int SCREEN_Y_CENTER = 120;
static float ASPECT_RATIO = (float)SCREEN_WIDTH/(float)SCREEN_HEIGHT;
#endif

#define PI   3.14159265358979323846
#define PI_2 6.283185307179586232


#endif /*-------------_GLOBALS_H_----------------------*/
