/*---------------------------------------------------------------------------

												Linked List Template   v1.0 
  Eneko Bilbao 1999
---------------------------------------------------------------------------*/

/*
    Linked List template for objects
    and pointers of objects
*/
    
/* STATUS
    -   adding, inserting, deleting works.
    -		uses a tail pointer to optimize adding.
*/

/* TODO
    -		make a double linked list.
    -   add a sorting function.    
*/    

/* BUGS
    -		none found
*/


#ifndef _LINKED_LIST_
#define _LINKED_LIST_

template <class S>
class item
{
	public:
			S  data;
			item *next;
};
			
template <class T>

class linked_list {
	private: 
			item<T> *first_ptr; // head of the list;
			item<T> *last_ptr;  // tail of the list;
			item<T> *runner;    // for parsing the list, avoid creation of a temp pointer
			int length;         // size of the list
			
	public:
			linked_list(T val)
			{
				first_ptr = new item<T>;
				first_ptr->data = val;
				first_ptr->next = 0;
				
				last_ptr = first_ptr;
				
				runner = 0;
				length = 1;
			}
			
            linked_list(T& val)
			{
				first_ptr = new item<T>;
				first_ptr->data = val;
				first_ptr->next = 0;
				
				last_ptr = first_ptr;
				
				runner = 0;
				length = 1;
			}
			
			linked_list(void)
			{
				first_ptr = 0;
				last_ptr = 0 ;
				runner = 0;
				length = 0;
			}

			~linked_list(void)
			{
				deleteList();
			}
			
			void deleteList(void)
			{
				if ( first_ptr == 0 )
					return;
				
				if ( first_ptr->next == 0 ) {
					delete first_ptr;
					first_ptr = 0;
					length = 0;
					return;
				}
				
				runner = first_ptr->next; ;
					
				while( runner->next != 0 )
				{
					delete first_ptr;
					first_ptr = runner;
					runner = runner->next;
				}
				
				delete runner;
				
				first_ptr = last_ptr = runner = 0;
				length = 0;
			}
			
			void addItem( const T& ele )
			{
				
				if ( first_ptr == 0 ) {
					first_ptr = new item<T>;
					first_ptr->data = ele;
					first_ptr->next = 0;
					last_ptr = first_ptr;
					length++;
					return;
				}
				
				last_ptr->next = new item<T>;
				
				last_ptr = last_ptr->next;
				last_ptr->data = ele;
				last_ptr->next = 0;
				
				length++;
			}

			void insertItem( int n, const T& ele )
			{
				item<T> *prev;
				
				if ( n > length )
					n = length;
				
				if ( n == 0 ) {
					prev = new item<T>;
					prev->data = ele;
					prev->next = first_ptr;
					first_ptr = prev;
					length++;
					return;
				}
				
				runner = first_ptr;
				prev = runner;
				
				for ( int i = 0 ; i < n; i++) {
					prev = runner ;
					runner = runner->next;
				}
				
				prev->next = new item<T>;
				prev = prev->next;
				prev->data = ele;
				prev->next = runner;
				
				length++;
			}
			
			T& getItem( const int n )
			{
				if ( n > length )
					return ( first_ptr->data);
				
				runner = first_ptr;
				
				for ( int i = 0 ; i < n ; i++)
					runner = runner->next;
				
				return( runner->data );
			}
			
			bool delItem( const int n = 0)
			{
				item<T> *prev;
				item<T> *next;
				
				if ( n > length )
					return ( false );
				
				if ( first_ptr->next == 0 ) {
					delete( first_ptr );
					first_ptr = 0 ;
					length--;
					return( true);
				}
				
				if ( n == 0 ) { 
					next =  first_ptr->next;
					delete first_ptr;
					first_ptr = next;
					length--;
					return( true );
				}
					
				runner = first_ptr;		
				prev = runner;
				next = runner->next;
				
				for ( int i = 0 ; i < n ; i++) {
					prev = runner;
					runner = runner->next;
					next = runner->next;
				}
				
				delete runner;
				length--;
				prev->next = next;
				return( true );
			}
			
			int getLength(void)
			{ return( length); }
			
			T& operator[]( const int n )
			{
				runner = first_ptr;
                
				for ( int i = 0 ; i < n ; i++)
					runner = runner->next;
				
				return( runner->data );
			}				
};

#endif /*----------------------------------*/
