/*---------------------------------------------------------------------------

                                                      Texture v1.0
  Eneko Bilbao 1999
---------------------------------------------------------------------------*/

/* STATUS
    -   Handles openGL Texture
    -		too few features
*/

/* TODO
    -		Multitexturing support
    -		texture merging for special effects
    -		light maps
    -		the on/off method used sucks, to much overhead.
*/    

/* BUGS
    -		none found 
*/


#ifndef _TEXTURE_
#define _TEXTURE_

#include <GL/glu.h>
#include "imageLoader.h"

class Texture
{
    private:
	    GLuint tex_ref;
	    GLubyte *pixmap;
        GLuint width, height;
        bool enable;
            
    public:
            Texture(void)
            {
                 pixmap = 0;   
                 tex_ref = 0;
				 enable = false;
            }
            
            Texture(int t, char* filename, int a, int repeat)
            {
                imageLoader pic;
                
                pixmap = 0;   
                tex_ref = 0;
                 
                switch(t)
			    {
				    case GIF:
					      pic.loadGIF(filename);
						  break;
					case PNG:
					      pic.loadPNG(filename);
					      break;
			    }
			    
				width = (GLuint)pic.getWidth();
                height = (GLuint)pic.getHeight();
                
                pixmap = new unsigned char[width*height*4];
		
			    pic.setAlpha(a);
                pic.copyImageToCharmap(pixmap, RGBA);
                
                glEnable(GL_TEXTURE_2D);
                glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    
                glGenTextures(1, &tex_ref);
                glBindTexture(GL_TEXTURE_2D, tex_ref);
    
			    if (repeat == 1 )
			    {
				    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
				    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
			    } else {
			        glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
				    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
			    }
			    
#ifdef _USE_3DFX_
                glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
                glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
#else		
			    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
                glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
#endif		
                glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, width, height, 
                                            0, GL_RGBA, GL_UNSIGNED_BYTE, pixmap);                
            }
            
            ~Texture(void)
            {
                if (pixmap != 0)
                    delete[] pixmap;
            }
             
            void    Init(char*);
            void    Reset(void);
	    
            GLuint    getRef(void);
            GLuint    getWidth(void);
            GLuint    getHeight(void);
            GLubyte*  getPixmap(void);
            
			inline void set(void)
			{ 
			  if(enable)
			    glEnable(GL_TEXTURE_2D);
			  else
				glDisable(GL_TEXTURE_2D);
			}
			
			inline void Enable(void)
			{ 
			    enable = true; 
			}
			
			inline void Disable(void)
			{ 
				enable = false;
			}
			
			inline bool isEnable(void)
			{ 
			  	return(enable);
			}
			
};
#endif /*----------------------------------------*/
